---
title: Selection.getRangeAt()
slug: Web/API/Selection/getRangeAt
tags:
  - API
  - Experimental
  - HTML Editing
  - Method
  - Reference
  - Selection
---
<div>{{ ApiRef("DOM") }}{{SeeCompatTable}}</div>

<p>The <strong><code>Selection.getRangeAt()</code></strong> method returns a range object representing one of the ranges currently selected.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>range</em> = <em>sel</em>.getRangeAt(<em>index</em>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code>index</code></dt>
	<dd>The zero-based index of the range to return. A negative number or a number greater than or equal to {{domxref("Selection.rangeCount")}} will result in an error.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The specified {{domxref("Range")}} object.</p>

<h2 id="Example">Example</h2>

<pre class="brush:js">let ranges = [];

sel = window.getSelection();

for(let i = 0; i &lt; sel.rangeCount; i++) {
 ranges[i] = sel.getRangeAt(i);
}
/* Each item in the ranges array is now
 * a range object representing one of the
 * ranges in the current selection */
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Selection API', '#dom-selection-getrangeat', 'Selection: getRangeAt()')}}</td>
			<td>{{Spec2('Selection API')}}</td>
			<td>Current</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Selection.getRangeAt")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("Selection")}}, the interface it belongs to.</li>
	<li><a href="/en-US/docs/XUL_Tutorial/Tree_Selection" title="XUL_Tutorial/Tree_Selection">Tree Selection</a> (for the <code>getRangeAt()</code> method on the <code>nsITreeSelection</code> interface)</li>
</ul>
